<template>
  <div>
    <modal-new-meal> </modal-new-meal>

    <div class="row">
      <div class="ui buttons">
        <button class="ui button">
           Repas
        </button>
        <div
          class="or"
          :data-text="count"
        ></div>
        <button
          class="ui positive button"
          @click="openModalNewMeal"
        >
          Ajouter
        </button>
      </div>
    </div>
    <br/>

    <div v-if="count">
      <table class="ui compact grey table">
        <thead>
          <tr>
            <th>Date</th>
            <th>Menu</th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="meal in meals"
            :key="meal._id"
          >
            <td class="positive">
              {{ meal.date.split('T')[0] }} {{ meal.period }}
              <div class="ui tiny basic icon right floated buttons">
                <div
                  class="ui button"
                  @click="removeMeal(meal._id)"
                >
                  <i class="ui red trash icon"></i>
                </div>
              </div>
            </td>
            <td>
              {{ meal.menu.dishes.join(', ') }}
            </td>
          </tr>
        </tbody>
      </table>
    </div>

    <div class="ui header" v-else>
      Aucun repas prévu
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import store from '@/store/Store'
import ModalNewMeal from './ModalNewMeal'

export default {
  name: 'Meals',
  store,
  beforeCreate () {
    store.dispatch('MealsStore/loadMeals')
      .then(
        (response) => {

        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
  },
  methods: {
    removeMeal (id) {
      store.dispatch('MealsStore/removeMeal', id)
        .then((response) => {
          this.$toastr.s('Bien supprimé')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    openModalNewMeal () {
      // eslint-disable-next-line
      $('#new-meal-modal')
        .modal('show')
    }
  },
  computed: {
    ...mapGetters({
      meals: 'MealsStore/meals',
      count: 'MealsStore/count'
    })
  },
  components: {
    ModalNewMeal
  }
}
</script>
